KUBERNETES(1)

NAME

kubectl set env - Update environment variables on a pod template

SYNOPSIS

kubectl set env [OPTIONS]

DESCRIPTION

Update environment variables on a pod template.

List environment variable definitions in one or more pods, pod templates. Add, update, or remove container environment variable definitions in one or more pod templates (within replication controllers or deployment configurations). View or modify the environment variable definitions on all containers in the specified pods or pod templates, or just those that match a wildcard.

If "--env -" is passed, environment variables can be read from STDIN using the standard env syntax.

Possible resources include (case insensitive):

pod (po), replicationcontroller (rc), deployment (deploy), daemonset (ds), job, replicaset (rs)

OPTIONS

--all=false
    If true, select all resources in the namespace of the specified resource types

--allow-missing-template-keys=true
    If true, ignore any errors in templates when a field or map key is missing in the template. Only applies to golang and jsonpath output formats.

-c, --containers="*"
    The names of containers in the selected pod templates to change - may use wildcards

--dry-run=false
    If true, only print the object that would be sent, without sending it.

-e, --env=[]
    Specify a key-value pair for an environment variable to set into each container.

-f, --filename=[]
    Filename, directory, or URL to files the resource to update the env

--from=""
    The name of a resource from which to inject environment variables

--keys=[]
    Comma-separated list of keys to import from specified resource

-k, --kustomize=""
    Process the kustomization directory. This flag can't be used together with -f or -R.

--list=false
    If true, display the environment and any changes in the standard format. this flag will removed when we have kubectl view env.

--local=false
    If true, set env will NOT contact api-server but run locally.

-o, --output=""
    Output format. One of: json|yaml|name|go-template|go-template-file|template|templatefile|jsonpath|jsonpath-file.

--overwrite=true
    If true, allow environment to be overwritten, otherwise reject updates that overwrite existing environment.

--prefix=""
    Prefix to append to variable names

-R, --recursive=false
    Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

--resolve=false
    If true, show secret or configmap references when listing variables

-l, --selector=""
    Selector (label query) to filter on

--template=""
    Template string or path to template file to use when -o=go-template, -o=go-template-file. The template format is golang templates [ ⟨http://golang.org/pkg/text/template/#pkg-overview⟩].

OPTIONS INHERITED FROM PARENT COMMANDS

--alsologtostderr=false
    log to standard error as well as files

--application-metrics-count-limit=100
    Max number of application metrics to store (per container)

--as=""
    Username to impersonate for the operation

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--azure-container-registry-config=""
    Path to the file containing Azure container registry configuration information.

--boot-id-file="/proc/sys/kernel/random/boot_id"
    Comma-separated list of files to check for boot-id. Use the first one that exists.

--cache-dir="/build/.kube/http-cache"
    Default HTTP cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cloud-provider-gce-lb-src-cidrs=130.211.0.0/22,209.85.152.0/22,209.85.204.0/22,35.191.0.0/16
    CIDRs opened in GCE firewall for LB traffic proxy health checks

--cluster=""
    The name of the kubeconfig cluster to use

--container-hints="/etc/cadvisor/container_hints.json"
    location of the container hints file

--containerd="unix:///var/run/containerd.sock"
    containerd endpoint

--context=""
    The name of the kubeconfig context to use

--default-not-ready-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for notReady:NoExecute that is added by default to every pod that does not already have such a toleration.

--default-unreachable-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for unreachable:NoExecute that is added by default to every pod that does not already have such a toleration.

--docker="unix:///var/run/docker.sock"
    docker endpoint

--docker-env-metadata-whitelist=""
    a comma-separated list of environment variable keys that needs to be collected for docker containers

--docker-only=false
    Only report docker containers in addition to root stats

--docker-root="/var/lib/docker"
    DEPRECATED: docker root is read from docker info (this is a fallback, default: /var/lib/docker)

--docker-tls=false
    use TLS to connect to docker

--docker-tls-ca="ca.pem"
    path to trusted CA

--docker-tls-cert="cert.pem"
    path to client certificate

--docker-tls-key="key.pem"
    path to private key

--enable-load-reader=false
    Whether to enable cpu load reader

--event-storage-age-limit="default=0"
    Max length of time for which to store events (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is a duration. Default is applied to all non-specified event types

--event-storage-event-limit="default=0"
    Max number of events to store (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is an integer. Default is applied to all non-specified event types

--global-housekeeping-interval=1m0s
    Interval between global housekeepings

--housekeeping-interval=10s
    Interval between container housekeepings

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-cadvisor-usage=false
    Whether to log the usage of the cAdvisor container

--log-dir=""
    If non-empty, write log files in this directory

--log-file=""
    If non-empty, use this log file

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--machine-id-file="/etc/machine-id,/var/lib/dbus/machine-id"
    Comma-separated list of files to check for machine-id. Use the first one that exists.

--match-server-version=false
    Require server version to match client version

--mesos-agent="127.0.0.1:5051"
    Mesos agent address

--mesos-agent-timeout=10s
    Mesos agent timeout

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--skip-headers=false
    If true, avoid header prefixes in the log messages

--stderrthreshold=2
    logs at or above this threshold go to stderr

--storage-driver-buffer-duration=1m0s
    Writes in the storage driver will be buffered for this duration, and committed to the non memory backends as a single transaction

--storage-driver-db="cadvisor"
    database name

--storage-driver-host="localhost:8086"
    database host:port

--storage-driver-password="root"
    database password

--storage-driver-secure=false
    use secure connection with database

--storage-driver-table="stats"
    table name

--storage-driver-user="root"
    database username

--token=""
    Bearer token for authentication to the API server

--update-machine-info-interval=5m0s
    Interval between machine info updates.

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

-v, --v=0
    number for the log level verbosity

--version=false
    Print version information and quit

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

EXAMPLE

      # Update deployment 'registry' with a new environment variable
      kubectl set env deployment/registry STORAGE_DIR=/local

      # List the environment variables defined on a deployments 'sample-build'
      kubectl set env deployment/sample-build --list

      # List the environment variables defined on all pods
      kubectl set env pods --all --list

      # Output modified deployment in YAML, and does not alter the object on the server
      kubectl set env deployment/sample-build STORAGE_DIR=/data -o yaml

      # Update all containers in all replication controllers in the project to have ENV=prod
      kubectl set env rc --all ENV=prod

      # Import environment from a secret
      kubectl set env --from=secret/mysecret deployment/myapp

      # Import environment from a config map with a prefix
      kubectl set env --from=configmap/myconfigmap --prefix=MYSQL_ deployment/myapp

      # Import specific keys from a config map
      kubectl set env --keys=my-example-key --from=configmap/myconfigmap deployment/myapp

      # Remove the environment variable ENV from container 'c1' in all deployment configs
      kubectl set env deployments --all --containers="c1" ENV-

      # Remove the environment variable ENV from a deployment definition on disk and
      # update the deployment config on the server
      kubectl set env -f deploy.json ENV-

      # Set some of the local shell environment into a deployment config on the server
      env | grep RAILS_ | kubectl set env -e - deployment/registry

SEE ALSO

kubectl-set(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!